YAZ User's Guide and Reference
Prev | Chapter 4. Generic server | Next

# Application Invocation

The finished application has the following invocation syntax (by way of `statserv_main()`):

appname [`-a `file``] [`-v `level``] [`-l `file``] [`-u `uid``] [`-c `config``] [`-t `minutes``]
[`-k `kilobytes``] [`-d `daemon``] [`-w `dir``] [`-ziST1`] [listener-spec...]

The options are:

`-a` `file`

  Specify a file for dumping PDUs (for diagnostic purposes). The special name `-` (dash) sends output to `stderr`.

`-S`

  Don't fork or make threads on connection requests. This is good for debugging, but not recommended for real operation: Although the server is asynchronous and non-blocking, it can be nice to keep a software malfunction (okay then, a crash) from affecting all current users.

`-1`

  Like `-S` but after one session the server exits. This mode is for debugging only.

`-T`

  Operate the server in threaded mode. The server creates a thread for each connection rather than a fork a process. Only available on UNIX systems that offers POSIX threads.

`-s`

  Use the SR protocol (obsolete).

`-z`

  Use the Z39.50 protocol (default). This option and `-s` complement each other. You can use both multiple times on the same command line, between listener-specifications (see below). This way, you can set up the server to listen for connections in both protocols concurrently, on different local ports.

`-l` `file`

  The logfile.

`-c` `config`

  A user option that serves as a specifier for some sort of configuration, usually a filename. The argument to this option is transferred to member `configname`of the `statserv_options_block`.

`-v` `level`

  The log level. Use a comma-separated list of members of the set {fatal,debug,warn,log,malloc,all,none}.

`-u` `uid`

  Set user ID. Sets the real UID of the server process to that of the given user. It's useful if you aren't comfortable with having the server run as root, but you need to start it as such to bind a privileged port.

`-w` `dir`

  The server changes to this directory during before listening on incoming connections. This option is useful when the server is operating from the inetd daemon (see `-i`).

`-i`

  Use this to make the the server run from the inetd server (UNIX only).

`-install`

  Use this to install the server as an NT service (Windows 2000/NT only). Control the server by going to the Services in the Control Panel.

`-remove`

  Use this to remove the server from the NT services (Windows 2000/NT only).

`-t` `minutes`

  Idle session timeout, in minutes.

`-k` `size`

  Maximum record size/message size, in kilobytes.

`-d` `daemon`

  Set name of daemon to be used in hosts access file. See hosts_access(5) and tcpd(8).

A listener specification consists of a transport mode followed by a colon (:) followed by a listener address. The transport mode is either `tcp`, `unix:` or `ssl`.

For TCP and SSL, an address has the form

        hostname | IP-number [: portnumber]

The port number defaults to 210 (standard Z39.50 port).

For UNIX, the address is the filename of socket.

For TCP/IP and SSL, the special hostname "@" is mapped to the address `INADDR_ANY`, which causes the server to listen on any local interface.

Examples:

        tcp:@:210

        ssl:@:3000

        unix:/tmp/yaz

Prev | Home | Next
The Backend Functions | Up | The YAZ client